// This is BSORTARR.CPP

// Binary Sorted Array class
// Project IMARK - a support program for indexing TeX and LaTeX documents
// (C) Jan Kybic, 1993

#include "bsortarr.h"


int BSortedArray::findPos( const Sortable& toFind) const
{ int l=0,h=lastElementIndex-lowerbound,m=(h+l)/2 ; ;

  while (h>l)
   {
     if (*(Sortable*)theArray[m]<toFind)
       l=m+1 ; else h=m ;
     m=(h+l)/2 ;
   }
  if (m==lastElementIndex-lowerbound)
    if (*(Sortable*)theArray[m]<toFind)
      return lastElementIndex+1 ;
  return m+lowerbound ;
}

void    BSortedArray::add( Sortable& toAdd )
{
        if (lastElementIndex==upperbound) reallocate( arraySize() + 1 );

        int insertionPoint=findPos(toAdd)-lowerbound ;
        memmove(theArray+insertionPoint+1,theArray+insertionPoint,
         sizeof(Object*)*(lastElementIndex-lowerbound-insertionPoint+1)) ;

		theArray[ insertionPoint ] = &toAdd;
		itemsInContainer++;
		lastElementIndex++;
}


Object& BSortedArray::findMember (const Sortable& toFind) const
{
  int pos=findPos(toFind) ;
  if (pos>lastElementIndex) return NOOBJECT ;
  Object& found=*(theArray[pos-lowerbound]) ;
  if (found!=toFind) return NOOBJECT ;
  return found ;
}